/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.mospcommon.system.action;

import jp.mosp.common.MosPAction;
import jp.mosp.common.common.BaseVo;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.mospcommon.system.dao.CmLimitStandardDao;
import jp.mosp.mospcommon.system.dto.CmLimitStandardDto;
import jp.mosp.mospcommon.system.vo.LimitStandardMasterCardVo;

/**
 * @author nakamura
 *
 */
public class LimitStandardMasterCardAction extends MosPAction {
	
	// コマンド
	private static final String	CMD_LIMIT_STANDARD_MASTER_CARD_SHOW		= "S2545";	// 表示(追加)
	private static final String	CMD_LIMIT_STANDARD_MASTER_CARD_SELECT	= "S2546";	// 表示(選択)
	private static final String	CMD_LIMIT_STANDARD_MASTER_CARD_INSERT	= "S2547";	// 登録
	private static final String	CMD_LIMIT_STANDARD_MASTER_CARD_UPDATE	= "S2548";	// 更新
																					
	
	/**
	 * コンストラクター
	 */
	public LimitStandardMasterCardAction() {
		super();
	}
	
	/* (非 Javadoc)
	 * @see jp.mosp.common.common.ActionInterface#action()
	 */
	public void action() throws Exception {
		// VOの取得		
		prepareVo(false);
		// 初期処理
		init();
		// コマンド毎の処理
		if (cmd.equals(CMD_LIMIT_STANDARD_MASTER_CARD_SHOW)) {
			// 表示
			show();
		} else if (cmd.equals(CMD_LIMIT_STANDARD_MASTER_CARD_SELECT)) {
			// 表示(キーで情報を検索)
			select();
		} else if (cmd.equals(CMD_LIMIT_STANDARD_MASTER_CARD_INSERT)) {
			// 新規登録
			insert();
		} else if (cmd.equals(CMD_LIMIT_STANDARD_MASTER_CARD_UPDATE)) {
			// 更新
			update();
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}
	
	@Override
	protected BaseVo getSpecificVo() {
		return new LimitStandardMasterCardVo();
	}
	
	@Override
	protected void init() throws Exception {
		// DBコネクション取得
		getConnection();
		// SYSTEM権限確認
		confirmSystemAuth();
		LimitStandardMasterCardVo vo = (LimitStandardMasterCardVo)getVo();
		vo.aryPltTermType = part().mospcode().getLimitStandardTermArray();
	}
	
	@Override
	protected void show() {
		LimitStandardMasterCardVo vo = (LimitStandardMasterCardVo)getVo();
		vo.setDefaultValues();
		vo.setMode(LimitStandardMasterCardVo.MODE_INSERT);
	}
	
	@Override
	protected void select() throws Exception {
		LimitStandardMasterCardVo vo = (LimitStandardMasterCardVo)getVo();
		// DAOの準備
		CmLimitStandardDao dao = new CmLimitStandardDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		// データの取得
		CmLimitStandardDto dto = dao.findForKey(key1);
		chkExist(dto);
		// VOに情報をセット
		vo.setFields(dto);
		vo.setMode(LimitStandardMasterCardVo.MODE_UPDATE);
		// セッションにDTOをセット
		setSessionDto(dto);
	}
	
	@Override
	protected void insert() throws Exception {
		LimitStandardMasterCardVo vo = (LimitStandardMasterCardVo)getVo();
		vo.setParams(request);
		vo.setPltDeleteFlag(String.valueOf(MospConst.DELETE_FLAG_OFF));
		// パラメータの妥当性確認
		vo.validate();
		// DTOの準備
		CmLimitStandardDto dto = new CmLimitStandardDto();
		vo.setDtoFields(dto);
		// DAOの準備
		CmLimitStandardDao dao = new CmLimitStandardDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		// 存在チェック
		chkDuplicate(dao.findForKey(dto.getLimitCode()));
		// データの挿入
		dao.insert(dto);
		// DTOの再取得
		dto = dao.findForKey(dto.getLimitCode());
		chkInsert(dto);
		// コミット
		commit();
		// モード設定
		vo.setMode(LimitStandardMasterCardVo.MODE_UPDATE);
		// メッセージ設定
		vo.setMessage(getMessage(MospConst.MSG_INSERT, ""));
		// セッションにDTOをセット
		setSessionDto(dto);
	}
	
	@Override
	protected void update() throws Exception {
		// DTOの取得
		CmLimitStandardDto dto = (CmLimitStandardDto)getSessionDto();
		LimitStandardMasterCardVo vo = (LimitStandardMasterCardVo)getVo();
		vo.setParams(request);
		// パラメータの妥当性確認
		vo.validate();
		// DTOの準備
		vo.setDtoFields(dto);
		// DAOの準備
		CmLimitStandardDao dao = new CmLimitStandardDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		// 排他確認
		chkExclusive(dto, dao.findForUpdate(dto.getLimitCode()));
		// データの更新
		dao.update(dto);
		// DTOの再取得
		CmLimitStandardDto retDto = dao.findForKey(dto.getLimitCode());
		chkUpdate(retDto);
		// コミット
		commit();
		// モード設定
		vo.setMode(LimitStandardMasterCardVo.MODE_UPDATE);
		// メッセージ設定
		vo.setMessage(getMessage(MospConst.MSG_UPDATE, ""));
		// セッションにDTOをセット
		setSessionDto(retDto);
	}
	
}
